using Avalonia.Media;
using Tesses.CMS.Client;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Serialization;
using System;
using ReactiveUI;
using System.Threading.Tasks;

namespace Tesses.CMS.Avalonia.Models;

public class FavoritesPageItem
{
    FavoritesItem item;
    
    public FavoritesPageItem(FavoritesItem item, Func<FavoritesItem,Task> fav)
    {
        this.item=item;
        ViewCommand = ReactiveCommand.CreateFromTask(async()=>{
            await fav(item);
        });
    }
    public string Name => item.MediaProperName;

    public string AuthorName => item.UserProperName;

    public IReactiveCommand ViewCommand {get;}
}