using Avalonia.Media;
using Tesses.CMS.Client;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Serialization;
using Newtonsoft.Json.Linq;

namespace Tesses.CMS.Avalonia.Models;

public enum FavoriteType {
    Movie,
    Show,
    Season,
    Episode,
    Album,
    AlbumTrack,
    MusicVideo,
    Program,
    ProgramRelease,
    Other,
    OtherFile

}

public class FavoritesItem 
{
    [JsonProperty("username")]
    public string Username {get;set;}="";

    [JsonProperty("type")]
    [JsonConverter(typeof(StringEnumConverter),typeof(CamelCaseNamingStrategy))]
    public FavoriteType Type {get;set;}=FavoriteType.Movie;

    [JsonProperty("userProperName")]
    public string UserProperName {get;set;}="";

    [JsonProperty("mediaName")]
    public string MediaName {get;set;}="";

    [JsonProperty("mediaProperName")]
    public string MediaProperName {get;set;}="";

    [JsonProperty("account")]
    public UserAccount Account {get;set;}=new UserAccount();

    [JsonProperty("media")]
    public JToken Media {get;set;}=JValue.CreateNull();

    public bool Equals(FavoritesItem item)
    {
        return Username == item.Username && Type == item.Type  && MediaName == item.MediaName;
    }

}