namespace Tesses.CMS.Avalonia.ViewModels;

using System;
using System.Collections.ObjectModel;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
using global::Avalonia.Threading;
using LibVLCSharp.Shared;

public partial class ActiveDownloadViewModel : ViewModelBase, IDisposable
{
    ActiveDownload download;
    Action remove;
    public ActiveDownloadViewModel(Action remove,ActiveDownload download)
    {
        this.remove = remove;
        this.download=download;
        this.download.ProgressChanged += ProgressChanged;
        this.download.Done += Done;
        Progress = (int)(this.download.Progress* 100); //for progress reasons
        Name = download.Name;
    }

    private void ProgressChanged(double obj)
    {
     
        Dispatcher.UIThread.Post(()=>{
            Progress = (int)(obj * 100);
        });
    }

    [ObservableProperty]
    private int _progress=0;

    [ObservableProperty]
    private string _name;

    [RelayCommand]
    public void Cancel()
    {
        download.TokenSource.Cancel();
        download.TokenSource.Dispose();
    }
    public void Dispose()
    {
        this.download.ProgressChanged -= ProgressChanged;
        this.download.Done -= Done;
    }

    private void Done()
    {
         Dispatcher.UIThread.Invoke(()=>{
            remove();
         });
    }
}