namespace Tesses.CMS.Avalonia.ViewModels;

using System.Collections.ObjectModel;
using System.Threading.Tasks;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
using Tesses.CMS.Avalonia.Models;
using Tesses.CMS.Avalonia.Views;

public partial class FavoritesPageViewModel : ViewModelBase
{
    MainViewModel mvm;
    public FavoritesPageViewModel(MainViewModel mvm)
    {
        this.mvm=mvm;
        Favorites.Clear();
       
                foreach(var item in App.EnumerateFavorites())
                {
                    Favorites.Add(new FavoritesPageItem(item,async (fpg)=>{
                        HomePageViewModel hpvm=new HomePageViewModel();
                        await hpvm.NavigateToAsync(item);
                        mvm.SetHome();
                        mvm.CurrentPage = hpvm;
                    }));
                }
            
       
    }

    public ObservableCollection<FavoritesPageItem> Favorites {get;}=new ObservableCollection<FavoritesPageItem>();
}