namespace Tesses.CMS.Avalonia.ViewModels.HomePages;

using System;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
using global::Avalonia.Controls;
using Tesses.CMS.Avalonia.Models;
using Tesses.CMS.Avalonia.Views.HomePages;
using Tesses.CMS.Client;

public partial class HomeShowListPageViewModel : ViewModelBase, IBackable
{
    HomePageViewModel homePage;
    HomeUserPageViewModel userPage;
    public HomeShowListPageViewModel(HomePageViewModel homePage,HomeUserPageViewModel userPage)
    {
        App.Log("In HomeShowListPageViewModel::ctor block begin");
        this.homePage = homePage;
        this.userPage = userPage;
        Task.Run(async()=>{
            App.Log("In HomeShowListPageViewModel::ctor::async block begin");
            
            await foreach(var item in App.Client.Shows.GetShowsAsync(userPage.Username))
            {
                try{
                _shows.Add(new ShowItem(item,await App.GetShowThumbnailAsync(userPage.Username,item.Name)));
                }catch(Exception ex)
                {
                    App.Log(ex.ToString());
                }
            }
            App.Log("In HomeShowListPageViewModel::ctor::async block end");
        }).Wait(0);
        App.Log("In HomeShowListPageViewModel::ctor block end");
    }

    [ObservableProperty]
    private ObservableCollection<ShowItem> _shows=new ObservableCollection<ShowItem>();
    [ObservableProperty]
    private MovieItem? _selectedListItem;
    partial void OnSelectedListItemChanged(MovieItem? value)
    {
        if (value is null) return;
        SelectedListItem=null;
        //homePage.CurrentPage = new HomeMoviePageViewModel(homePage,this,userPage.Account,value);
        //homePage.CurrentPage = new HomeUserPageViewModel(homePage,this,value);

        
    }

    public ViewModelBase Back()
    {
        return userPage;
    }
    
}