namespace Tesses.CMS.Avalonia.ViewModels.HomePages;

using System.Collections.ObjectModel;
using System.Threading.Tasks;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
using Tesses.CMS.Avalonia.Views.HomePages;
using Tesses.CMS.Client;

public partial class HomeUserListPageViewModel : ViewModelBase
{
    HomePageViewModel homePage;
    public HomeUserListPageViewModel(HomePageViewModel homePage)
    {
        this.homePage = homePage;
        Task.Run(async()=>{
            await foreach(var item in App.Client.Users.GetUsersAsync())
            {
                App.Log($"Got user {item}");
                _users.Add(item);
            }
        }).Wait(0);
    }

    [ObservableProperty]
    private ObservableCollection<UserAccount> _users=new ObservableCollection<UserAccount>();
    [ObservableProperty]
    private UserAccount? _selectedListItem;
    partial void OnSelectedListItemChanged(UserAccount? value)
    {
        if (value is null) return;
        App.Log($"Selected account {value.ProperName}");
        SelectedListItem=null;
        homePage.CurrentPage = new HomeUserPageViewModel(homePage,this,value);
    }

   
}