namespace Tesses.CMS.Avalonia.ViewModels;

using System.Threading.Tasks;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
public partial class SettingsPageViewModel : ViewModelBase
{
    MainViewModel mvm;
    public SettingsPageViewModel(MainViewModel mvm)
    {
        this.mvm = mvm;
    }

    [RelayCommand]
    private async Task Browse()
    {
        await App.Platform.BrowseForDownloadDirectoryAsync();
        if(App.Platform.PlatformUsesNormalPathsForDownload)
            Path = App.Platform.Configuration.DownloadPath;
    }

    [RelayCommand]
    private async Task Save()
    {
        if(App.Platform.PlatformUsesNormalPathsForDownload)
            App.Platform.Configuration.DownloadPath = Path;
        
        App.Platform.Configuration.ServerUrl = Url;
        App.Platform.Configuration.Log = Log;
        App.Platform.Configuration.CacheResources = CacheResources;

        await App.Platform.WriteConfigurationAsync();
        App.Client.RootUrl = App.Platform.Configuration.ServerUrl;
        string title=App.GetApplicationTitle();
        mvm.Title = title;
        if(App.Window != null)
            App.Window.Title = title;
    }

    [ObservableProperty]
    private string _path = App.Platform.PlatformUsesNormalPathsForDownload ? App.Platform.Configuration.DownloadPath : "<Not Editable>";

    [ObservableProperty]
    private string _url = App.Platform.Configuration.ServerUrl;
    [ObservableProperty]
    private bool _log = App.Platform.Configuration.Log;
    [ObservableProperty]
    private bool _cacheResources = App.Platform.Configuration.CacheResources;
}