

using System;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Avalonia.Controls;
using Avalonia.Media;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
using LibVLCSharp.Shared;
using ReactiveUI;
using Tesses.CMS.Avalonia.Models;
using Tesses.CMS.Avalonia.Views;
using Tesses.CMS.Client;
namespace Tesses.CMS.Avalonia.ViewModels;

public partial class VideoPlayerViewModel : ViewModelBase, IDisposable
{
   bool played=false;

    public VideoPlayerViewModel()
    {
        BrowseCommand = ReactiveCommand.CreateFromTask(BrowseAsync);
        /*

        
        LibVLC vlc=new LibVLC("--input-repeat=65535");

        Player=new MediaPlayer(new Media(vlc,new StreamMediaInput(strm)));
        
        Player.Play();*/
    }

    public VideoPlayerViewModel(string path)
    {
        BrowseCommand = ReactiveCommand.CreateFromTask(BrowseAsync);
        played=true;
        Stream = File.OpenRead(path);
        Thread thrd=new Thread(()=>{
            Thread.Sleep(1000);
        Player=new MediaPlayer(new Media(vlc,new StreamMediaInput(Stream)));
        
        Player.Play();
        });
        thrd.Start();
    }
    LibVLC vlc=new LibVLC("--input-repeat=65535");
    [ObservableProperty]
    private MediaPlayer? _player;

    
   
    Stream? Stream=null;

    public void Dispose()
    {
        
        Thread thrd=new Thread(()=>{
            Player?.Stop();
            Thread.Sleep(10000);
            Player?.Dispose();
            Stream?.Dispose();
            vlc.Dispose();
        });
        thrd.Start();
    }

    public IReactiveCommand BrowseCommand {get;}
    public async Task BrowseAsync()
    {
        if(App.Window != null)
        {
            await OpenAsync(App.Window);
        }
        if(App.MainView != null)
        {
            await OpenAsync(TopLevel.GetTopLevel(App.MainView));
        }
    }

    private async Task OpenAsync(TopLevel? topLevel)
    {
        if(topLevel != null)
        {
            var res=new global::Avalonia.Platform.Storage.FilePickerOpenOptions();
            res.AllowMultiple=false;
            res.Title = "Browse for video";
            
            var first = (await topLevel.StorageProvider.OpenFilePickerAsync(res)).FirstOrDefault();
            if(first != null)
            {
                if(played)
                {
                    var player = Player;
                    var strm = Stream;
                     Thread thrd=new Thread(()=>{
            player?.Stop();
            Thread.Sleep(10000);
            player?.Dispose();
            strm?.Dispose();
            
        });
        thrd.Start();
                }
                played=true;
                
            
                Stream = await first.OpenReadAsync();

        Player=new MediaPlayer(new Media(vlc,new StreamMediaInput(Stream)));
        
        Player.Play();
            }
        }
    }
}