using System;
using System.Text;
using Avalonia;
using Avalonia.Controls;
using Avalonia.Controls.Documents;
using Avalonia.Data;
using Avalonia.Media;
using CommunityToolkit.Mvvm.ComponentModel;

namespace Tesses.CMS.Avalonia.Views;

public class InlineText : WrapPanel
{
    /// <summary>
        /// MediaPlayer Data Bound property
        /// </summary>
        /// <summary>
        /// Defines the <see cref="Text"/> property.
        /// </summary>
        public static readonly DirectProperty<InlineText, string> TextProperty =
            AvaloniaProperty.RegisterDirect<InlineText, string>(
                nameof(Text),
                o => o.Text,
                (o, v) => o.Text = v,
                defaultBindingMode: BindingMode.TwoWay);
        string text="";
        public string Text {
            get => text;
            set{
                try{
                text = value;
                SetText();
                }catch(Exception ex)
                {
                    _=ex;
                    Console.WriteLine(ex);
                }
            }
        }

        private void SetText()
        {
            this.Children.Clear();
            StringBuilder b = new StringBuilder();

            for (int i = 0; i < text.Length; i++)
            {
                if (StartsWithAt(text, i, "http:") || StartsWithAt(text, i, "https:") || StartsWithAt(text, i, "ftp:") || StartsWithAt(text, i, "ftps:") || StartsWithAt(text, i, "sftp:") || StartsWithAt(text, i, "magnet:"))
                {
                     if(b.Length > 0)
                    {
                        this.Children.Add(new TextBlock(){Text = b.ToString()});
                        b.Clear();
                    }
                    StringBuilder b2 = new StringBuilder();
                    for (; i < text.Length; i++)
                    {
                        if (text[i] == '\n' || text[i] == ' ')
                        {
                            b.Append(text[i]);
                            break;
                        }
                        b2.Append(text[i]);
                    }
                    var tb = new TextBlock(){Text = b2.ToString()};
                    tb.Foreground = new SolidColorBrush(Color.FromRgb(0,0,255));
                    tb.TextDecorations = TextDecorations.Underline;
                    
                    
                    
                    tb.Tapped += (sender,e)=>{
                        App.LaunchUrl(b2.ToString());
                    };
                    this.Children.Add(tb);
                }
                else
                {
                    b.Append(text[i]);
                }
            }
              if(b.Length > 0)
                    {
                        this.Children.Add(new TextBlock(){Text = b.ToString()});
                        b.Clear();
                    }
        }

        private static bool StartsWithAt(string str, int indexof, string startsWith)
        {
            if (str.Length - indexof < startsWith.Length) return false;
            for (int i = 0; i < startsWith.Length; i++)
            {
                if (str[i + indexof] != startsWith[i]) return false;
            }
            return true;
        }

        public InlineText()
        {
            
            
        }
}