using System;
using System.Collections.Generic;
using Newtonsoft.Json;

namespace Tesses.CMS.Client
{
     public class MovieContentMetaData
    {
        [JsonProperty("has_movie_torrent")]
        public bool HasMovieTorrent{get;set;}
        [JsonProperty("movie_torrent_url")]
        public string MovieTorrentUrl {get;set;}
        [JsonProperty("has_movie_with_extras_torrent")]
        public bool HasMovieWithExtrasTorrent{get;set;}
        [JsonProperty("movie_with_extras_torrent_url")]
        public string MovieWithExtrasTorrentUrl {get;set;}

        [JsonProperty("has_browser_stream")]
        public bool HasBrowserStream {get;set;}
        [JsonProperty("has_download_stream")]
        public bool HasDownloadStream {get;set;}
        [JsonProperty("browser_stream")]
        public string BrowserStream {get;set;}
        

        [JsonProperty("download_stream")]
        public string DownloadStream {get;set;}
        [JsonProperty("has_poster")]
        public bool HasPoster {get;set;} 

        [JsonProperty("poster_url")]
        public string PosterUrl {get;set;}
        
        [JsonProperty("has_thumbnail")]
        public bool HasThumbnail {get;set;}

        [JsonProperty("thumbnail_url")]

        public string ThumbnailUrl {get;set;}

        [JsonProperty("subtitle_streams")]
        public List<SubtitleStream> SubtitlesStreams {get;set;}=new List<SubtitleStream>();

        [JsonProperty("extra_streams")]
        public List<ExtraDataStream> ExtraStreams {get;set;}=new List<ExtraDataStream>();
    }
    public class ExtraDataStream
    {
        [JsonProperty("is_dir")]
        public bool IsDir {get;set;}
        [JsonProperty("name")]
        public string Name {get;set;}

        [JsonProperty("items")]

        public List<ExtraDataStream> Items {get;set;}=new List<ExtraDataStream>();
        [JsonProperty("url")]
        public string Url {get;set;}
    }
    public class SubtitleStream 
    {
        [JsonProperty("language_code")]
        public string LanguageCode {get;set;}="";

        [JsonProperty("url")]

        public string SubtitleUrl {get;set;}
    }

    public class Movie 
    {
        [JsonProperty("proper_name")]
        public string ProperName {get;set;}
        [JsonProperty("name")]
        public string Name {get;set;}
        [JsonProperty("creation_time")]
        public DateTime CreationTime {get;set;}
        [JsonProperty("last_updated_time")]
        public DateTime LastUpdated {get;set;}
        [JsonProperty("description")]
        public string Description {get;set;}
    }
}