using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Serialization;

namespace Tesses.CMS
{
     [JsonConverter(typeof(StringEnumConverter),typeof(SnakeCaseNamingStrategy))]
    public enum EventType
    {
        MovieCreate,
        MovieUpdate,
        ShowCreate,
        ShowUpdate,
        AlbumCreate,
        AlbumUpdate
    }
    public class CMSEvent
    {
        [JsonProperty("eventtype")]
        public EventType Type {get;set;}

        [JsonProperty("username")]
        public string Username {get;set;}="";
        [JsonProperty("userpropername")]
        public string UserProperName {get;set;}="";


        [JsonProperty("name")]
        public string Name {get;set;}="";

        [JsonProperty("propername")]
        public string ProperName {get;set;}="";

        [JsonProperty("description")]
        public string Description {get;set;}="";

        [JsonProperty("body")]
        public string Body {get;set;}="";
    }


}