using System;
using System.Collections.Generic;
using Newtonsoft.Json;

namespace Tesses.CMS
{
    public class Show
    {
        [JsonIgnore]
        public long Id {get;set;}
        [JsonProperty("proper_name")]
        public string ProperName {get;set;}="";
        [JsonProperty("name")]
        public string Name {get;set;}="";
        [JsonIgnore]
        public long UserId {get;set;}
        [JsonProperty("creation_time")]
        public DateTime CreationTime {get;set;} = DateTime.Now;
        [JsonProperty("last_updated_time")]
        public DateTime LastUpdated {get;set;} = DateTime.Now;
        [JsonProperty("description")]
        public string Description {get;set;}="";

        

        public object Scriban(CMSConfiguration configuration,string user)
        {
            return new {
                Proper =  System.Web.HttpUtility.HtmlEncode( ProperName),
                Name = System.Web.HttpUtility.HtmlEncode(Name),
                Description = System.Web.HttpUtility.HtmlEncode(Description),
                Thumbnail = $"{configuration.Root.TrimEnd('/')}/content/{user}/show/{Name}/thumbnail.jpg"
            };
        }

    }
}